# -*- coding: utf-8 -*-

# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


from cxnet.netlink.rtnl import *

from command import command
from cxutil import flags,cmask
from cxutil.utils import opts
from cxutil.exceptions import Dump


class rtnl_handler(rtnl_socket):
	"""
	Netlink signal provider
	"""
	signal = None
	parser = None

	def __init__(self,signal):
		self.signal = signal
		self.parser = rtnl_msg_parser()

		rtnl_socket.__init__(self, groups = RTNLGRP_IPV4_IFADDR | RTNLGRP_IPV4_ROUTE | RTNLGRP_LINK)

	def handle(self):
		(l,msg) = self.recv()
		sig = self.parser.parse(msg)
		self.signal(("netlink","netlink.%s.%s" % (sig["type"],sig["action"])), sig)



class netlink (command):
	"""
	Netlink monitoring
	"""
	mask = flags.Esoteric

	def init(self,opts):
		if not opts.call_mask & cmask.Immediate:
			self.s = rtnl_handler(self.signal)
			opts.esoteric.bus.put("monitor",("register",self.s.fd,self.s.handle))

	def postUp(self,opts):
		pass
